/**
 * <p>File: Exc0103.java</p>
 * <p>Title: Cryptography</p>
 * <p>Description: Course on introduction to typography</p>
 * <p>Date: March 2015</p>
 * @author Faton M. Berisha
 * @version 1.0.0
 *
 * <p>
 * Exercise:
 * Dekriptoni kodin
 * JGRMQOYGHMVBJWRWQFPWHGFFDQGFPFZRKBEEBJIZQQOCIBZKLF
 * AFGQVFZFWWEOGWOPFGFHWOLPHLRLOLFDMFGQWBLWBWQOLKFWBY
 * LBLYLFSFLJGRMQBOLWJVFPFWQVHQWFFPQOQVFPQOCFPOGFWFJI
 * GFQVHLHLROQVFGWJVFPFOLFHGQVQVFILEOGQILHQFQGIQVVOSF
 * AFGBWQVHQWIJVWJVFPFWHGFIWIHZZRQGBABHZQOCGFHX");
 *		t enkriptuar me shifruesin me zvendsim mono-alphabetic.
 *		Shfrytzoni histogramin
 *		nga figura.
 * </p>
 */

import java.util.*;

import cryptography.*;

public class Exc0103 {
	public static void main(String[] args) {
		MonoAlphabetic ma = new MonoAlphabetic();

		StringBuffer buff
			= new StringBuffer("JGRMQOYGHMVBJWRWQFPWHGFFDQGFPFZRKBEEBJIZQQOCIBZKLF");
			buff.append("AFGQVFZFWWEOGWOPFGFHWOLPHLRLOLFDMFGQWBLWBWQOLKFWBY");
			buff.append("LBLYLFSFLJGRMQBOLWJVFPFWQVHQWFFPQOQVFPQOCFPOGFWFJI");
			buff.append("GFQVHLHLROQVFGWJVFPFOLFHGQVQVFILEOGQILHQFQGIQVVOSF");
			buff.append("AFGBWQVHQWIJVWJVFPFWHGFIWIHZZRQGBABHZQOCGFHX");

		String code = new String(buff);
		System.out.println(code);
		
		List<Map.Entry<?, Double>> sortedEng = ma.sort(MonoAlphabetic.FREQUENCY_ENG);
		System.out.println(sortedEng);
		
		Map<Character, Double> frequency = ma.letterFrequency(code);
		List<Map.Entry<?, Double>> sorted = ma.sort(frequency);
		System.out.println(sorted);
		
		Map<Character, Character> key = new HashMap<Character, Character>(26);
		for (int i = 0; i < 26; i++) {
			Character ch = new Character((char)(i + 'A'));
			key.put(ch, ch);
		}
		
		Map<String, Double> bigramFrequency = ma.multigramFrequency(code, 2);
		List<Map.Entry<?, Double>> sortedBigramFrequency = ma.sort(bigramFrequency);
		System.out.println(sortedBigramFrequency);

		Map<String, Double> trigramFrequency = ma.multigramFrequency(code, 3);
		List<Map.Entry<?, Double>> sortedTrigramFrequency = ma.sort(trigramFrequency);
		System.out.println(sortedTrigramFrequency);

/*		// e, t, th, the 
		key.put(new Character('F'), new Character('e'));
		key.put(new Character('Q'), new Character('t'));
		key.put(new Character('V'), new Character('h'));
		String message = ma.analysis(code, key);
		System.out.println(message);
*/		
/*		// W afr e, WW, thH, thHt
		key.put(new Character('W'), new Character('s'));
		key.put(new Character('H'), new Character('a'));
		message = ma.analysis(code, key);
		System.out.println(message);
*/		
/*		// seeP, theP, tO, OtheG, eaGth, aGe
		key.put(new Character('P'), new Character('m'));
		key.put(new Character('O'), new Character('o'));
		key.put(new Character('G'), new Character('r'));
		message = ma.analysis(code, key);
		System.out.println(message);
*/		
/*		// reasoL, thaL, sJheme, sRstems, eDtreme 
		key.put(new Character('L'), new Character('n'));
		key.put(new Character('J'), new Character('c'));
		key.put(new Character('R'), new Character('y'));
		key.put(new Character('D'), new Character('x'));
		message = ma.analysis(code, key);
		System.out.println(message);
*/
/*		// cryMtoYraMhBc, exMerts, extremeZy, neAertheZess,
		// Eor, Ce, secIre, trIth, InEortInate
		key.put(new Character('M'), new Character('p'));
		key.put(new Character('Y'), new Character('g'));
		key.put(new Character('B'), new Character('i'));
		key.put(new Character('Z'), new Character('l'));
		key.put(new Character('A'), new Character('v'));
		key.put(new Character('E'), new Character('f'));
		key.put(new Character('C'), new Character('b'));
		key.put(new Character('I'), new Character('u'));
		message = ma.analysis(code, key);
		System.out.println(message);
*/
/*		// Kifficult, nes, hoSever, breaX
		key.put(new Character('K'), new Character('d'));
		key.put(new Character('S'), new Character('w'));
		key.put(new Character('X'), new Character('k'));
		message = ma.analysis(code, key);
		System.out.println(message);
*/
/*		buff  = new StringBuffer("Cryptographic systems are extremely difficult to build. ");
		buff.append("Nevertheless, for some reason, many non experts insist ");
		buff.append("on designing new encryption schemes that seem to them to be ");
		buff.append("more secure than any other scheme on earth. ");
		buff.append("The unfortunate truth, however, is that such schemes ");
		buff.append("are usually trivial to break");
		
		message = new String(buff);
		System.out.println(message);
		
		Map<Character, Character> encKey = new HashMap<Character, Character>(26);
		for (int i = 0; i < 26; i++) {
			Character keyChar = new Character((char)(i + 'A'));
			if (key.containsKey(keyChar)) {
				char ch = key.get(keyChar).charValue();
				Character valueChar = new Character(Character.toUpperCase(ch));
				encKey.put(valueChar, keyChar);
			}
		}
		
		code = ma.encrypt(message, encKey);
		System.out.println(code);
		message = ma.decrypt(code, encKey);
		System.out.println(message);
*/
	}
}
